' +---------------+-----------+
' | Inky Breeding | Ryan Touk |
' +---------------+-----------+
' |  8.24.2013 . Creation (in Monkey 70e for Ludum Dare #27)
' |   .25.     . Added paper graphics, intro screen, ending screen,
' |                released Version 1.0 for Ludum Dare competition


'? > README
'
' This atrocious code (and corresponding awful graphics) was created
' for Ludum Dare #27, a 48-hour game contest/jam.
' This time the theme was "10 Seconds", and you can see I took it literally.
'
' The only pre-existing component was the MFont module, for loading/drawing
' homemade PNG fonts, which I wrote for a previous game.
'
' This program is intended for the Flash target in Monkey v70e.
' Thanks for taking a look!
'
'  - Ryan Touk 25 Aug 2013



'? > Imports
Strict
Import mojo
Import MFont

Const Version:String = "1.0"

Global MF:MFont.MFont = New MFont.MFont ' weird module syntax

Class SW_Box
  Field x:Int
  Field y:Int
  Field w:Int
  Field h:Int
  Field Scale:Float ' became redundant, since Scale = w = h
  Field IsGreen:Bool
  Field AlphaP:Int
  Field Depth:Int
End Class

Class SW_Game Extends App

  Field GameMode:Int = 0
  Field BL:List<SW_Box>
  Field Level:Int
  Field Greens:Int
  Field Got:Int
  Field StartTime:Int, Time:Int
  Field Odds:Int
  Field FadeScale:Float
  
  Field WallWidth:Float
  Field DWallWidth:Float
  
  Field Snd:Sound[5]
  
  
  ' Many image variables instead of an array... gross.
  Global iGray:Image
  Global iGreen:Image
  Global iRed:Image
  Global iBlue:Image
  Global iBox:Image
  Global iBoxL:Image
  Global iBoxR:Image
  Global iWhite:Image
  Global iWhite2:Image
  
  ' Globals randomly declared in the Game class... hmm.
  
  Global Rounds:Int
  Global TotalMS:Int
  Global LostIt:Bool

  Method LoadMenu:Void(Lost:Bool)
    BL.Clear()
    BL.AddLast(New SW_Box)
    If (Lost)
      FadeScale = 1.0
    Else
      FadeScale = 0.0
    endif
    Local Spawn:SW_Box = BL.Last()
    Spawn.Scale = DeviceHeight()/4
    Spawn.x = DeviceWidth()/2 - Spawn.Scale/2
    Spawn.y = DeviceHeight()*0.6 - Spawn.Scale/2
    Spawn.w = Spawn.Scale
    Spawn.h = Spawn.Scale
    Spawn.AlphaP = 0
    Spawn.IsGreen = True
    Got = 0
    Greens = 1
    GameMode = 0
    PlayMusic("intro.mp3", 1)
    StartTime = Millisecs()
    WallWidth = 0
    DWallWidth = 0
    LostIt = Lost
  End Method

  Method OnCreate:Int()
    BL = New List<SW_Box>
    
    MF = LoadMFont("font")
    
    Snd[0] = LoadSound("click.mp3")
    Snd[1] = LoadSound("spawn.mp3")
    Snd[2] = LoadSound("win.mp3")
    Snd[3] = LoadSound("lose.mp3")
    Snd[4] = LoadSound("scream.mp3")

    SetChannelVolume(0, 0.3)
    SetChannelVolume(1, 0.4)
    SetChannelVolume(2, 0.1)
    SetChannelVolume(3, 0.2)
    SetChannelVolume(4, 0.3)
    
    iGray = LoadImage("gray.jpg", 1)
    iGreen = LoadImage("green.jpg", 1)
    iRed = LoadImage("red.jpg", 1)
    iBlue = LoadImage("blue.jpg", 1)
    iBox = LoadImage("box.jpg", 1)
    iBoxL = LoadImage("boxL.jpg", 1)
    iBoxR = LoadImage("boxR.jpg", 1)
    iWhite = LoadImage("main.jpg", 1)
    iWhite2 = LoadImage("end.jpg", 1)
    
    SetUpdateRate(60)
    
    LoadMenu(False)
    
    Return 0
  End Method
  
  Method LoadLevel:Void(num:Int)
    If (num = 1)
      Rounds = 1
      TotalMS = 0
    Endif
    GameMode = 1
    Level = num
    Greens = 0
    Got = 0
    Seed = Level + 1
    
    BL.Clear()
    Local Width:Int = 2 + Floor(Level/3)
    Local Height:Int = 2 + Floor(Level/4)
    Odds = 70 - Level
    Local Scale:Float = DeviceHeight() / Height
    Local f:Float = DeviceWidth() / Width
    If (f < Scale)
      Scale = f
    Endif
    
    For Local y:Int = 0 To Height - 1
      For Local x:Int = 0 To Width - 1
        BL.AddLast(New SW_Box)
        Local this:SW_Box = BL.Last()
        this.x = Int(DeviceWidth()/2 - (Width * 0.5 * Scale) + x*Scale)
        this.y = Int(DeviceHeight()/2 - (Height * 0.5 * Scale) + y*Scale)
        this.Scale = Scale
        this.w = Scale
        this.h = Scale
        this.AlphaP = 0
        this.Depth = 1
        If (Rnd()*100 >= Odds)
          this.IsGreen = True
          Greens += 1
        else
          this.IsGreen = False
        endif
      Next x
    Next y

    If (Greens = 0)
      Greens = 1
      BL.Last().IsGreen = True
    Endif
    
    PlayMusic("ten.mp3", 0)
    StartTime = Millisecs()
  End Method
  
  Method OnRender:Int()
    
    Select GameMode
      Case 0
        'Cls 32,32,32
      Case 1
        'Cls 16,64,192
      Case 2
        'Cls 225,32,32
    End Select
    
    SetAlpha(1.0)
    SetColor(255,255,255)
    If (GameMode = 1)
      DrawImage(iBlue, 0, 0, 0, 1.0, 1.0, 0)
      WallWidth = (DeviceWidth() * (Millisecs() - StartTime) / 20000)
      If (WallWidth > DWallWidth)
        DWallWidth = WallWidth
      Else
        DWallWidth += (WallWidth - DWallWidth) * 0.1
      Endif
      If (false)
        DrawImage(iBoxL, DWallWidth - 320, 0, 0, 1.0, 1.0, 0)
        DrawImage(iBoxR, 640 - DWallWidth, 0, 0, 1.0, 1.0, 0)
      Else
        DrawImageRect(iBoxL, 0, 0, 0, 0, DWallWidth, 480)
        DrawImageRect(iBoxR, 640 - DWallWidth, 0, 320 - DWallWidth, 0, DWallWidth, 480)
      endif
      'SetColor(32,128,255)
      'DrawRect(0, 0, DWallWidth, DeviceHeight())
      'DrawRect(DeviceWidth() - DWallWidth, 0, DWallWidth, DeviceHeight())
    Else
      If (LostIt)
        DrawImage(iWhite2, 0, 0, 0, 1.0, 1.0, 0)
        MF.Write(360, 50, String(Rounds), 0.5, false, False)
        MF.Write(360, 112, String(Int(TotalMS/1000)) + "." + String(Int((TotalMS Mod 1000)/100)), 0.5, false, False)
      Else
        DrawImage(iWhite, 0, 0, 0, 1.0, 1.0, 0)
        MF.Write(5, 450, Version, 0.2, False, False)
      Endif
      if (GameMode = 0 And FadeScale >= 0.01)
        'SetColor(32,128,255)
        'DrawRect(320.0 - FadeScale * 320.0, 240.0 - FadeScale * 240.0, FadeScale * 640.0, FadeScale * 480.0)
        DrawImage(iBox, 320.0 - FadeScale * 320.0, 240.0 - FadeScale * 240.0, 0, FadeScale * 2.0, FadeScale * 2.0, 0)
        FadeScale *= 0.7'0.5
      Endif
    Endif
    SetColor(255,255,255)
    For Local B:SW_Box = Eachin BL
      SetAlpha(1.0)
      'SetColor(192,192,192)
      'DrawRect(B.x + B.w * 0.1, B.y + B.h * 0.1, B.w * 0.8, B.h * 0.8)
      DrawImage(iGray, B.x + B.w * 0.1, B.y + B.h * 0.1, 0, B.Scale / 128.0 * 0.8, B.Scale / 128.0 * 0.8, 0)
      If (B.AlphaP > 0)
        SetAlpha(B.AlphaP * 0.01)
        If (B.IsGreen)
          'SetColor(0,255,0)
          DrawImage(iGreen, B.x + B.w * 0.1, B.y + B.h * 0.1, 0, B.Scale / 128.0 * 0.8, B.Scale / 128.0 * 0.8, 0)
        else
          'SetColor(255,0,0)
          DrawImage(iRed, B.x + B.w * 0.1, B.y + B.h * 0.1, 0, B.Scale / 128.0 * 0.8, B.Scale / 128.0 * 0.8, 0)
        Endif
        'DrawRect(B.x + B.w * 0.1, B.y + B.h * 0.1, B.w * 0.8, B.h * 0.8)
        'DrawRect(B.x, B.y, B.w, B.h)
      Endif
    Next
    
    Return 0
  End Method
  
  Method OnUpdate:Int()
    

    Local mx:Int = MouseX()
    Local my:Int = MouseY()
    For Local B:SW_Box = Eachin BL
      If (mx >= B.x) And (mx < B.x + B.w) And (my >= B.y) And (my < B.y + B.h)
        If (B.AlphaP < 100)
          B.AlphaP += 25
          If (B.AlphaP > 100)
            B.AlphaP = 100
          Endif
        Endif
        If (MouseHit(MOUSE_LEFT) And (GameMode = 1 Or (Millisecs() - StartTime > 1000)))
          If (B.IsGreen)
            BL.RemoveEach(B)
            Got += 1
            PlaySound(Snd[0], 0)
          Else
            If (B.Depth < 4)
              For Local gx:Int = 0 To 1
                For Local gy:Int = 0 To 1
                  BL.AddFirst(New SW_Box)
                  Local Spawn:SW_Box = BL.First()
                  Spawn.Scale = 0.5 * B.Scale
                  Spawn.x = B.x + Spawn.Scale * gx
                  Spawn.y = B.y + Spawn.Scale * gy
                  Spawn.w = Int(Spawn.Scale)
                  Spawn.h = Int(Spawn.Scale)
                  Spawn.AlphaP = 100'B.AlphaP
                  Spawn.Depth = B.Depth + 1
                  If (Rnd()*100 >= Odds)
                    Spawn.IsGreen = True
                    Greens += 1
                  Else
                    Spawn.IsGreen = False
                  Endif
                  PlaySound(Snd[1], 1)
                Next gy
              Next gx
            Else
              PlaySound(Snd[4], 4)
            Endif
            BL.RemoveEach(B)
          endif
        endif
      Else
        If (B.AlphaP > 0)
          B.AlphaP -= 3
          If (B.AlphaP < 0)
            B.AlphaP = 0
          Endif
        Endif
      Endif
    next
    
    Select GameMode
      Case 0
        If (Got = Greens)
          LoadLevel(1)
        Endif
      Case 1
        If (Got = Greens)
          TotalMS += (Millisecs() - StartTime)
          Rounds += 1
          PlaySound(Snd[2], 2)
          LoadLevel(Level + 1)
        Elseif (Millisecs() - StartTime >= 10000)
          TotalMS += (Millisecs() - StartTime)
          PlaySound(Snd[3], 3)
          LoadMenu(True)
        Endif
    End Select
    
    Return 0
  End Method
  
End Class

Function Main:Int()
  New SW_Game
  
  Return 0
End Function

' EOF