Import mojo

Class MFont
  Field Frames:Int
  Field Img:Image
  Field Chars:Int[]
  Field Widths:Int[]
  
  Method MFontWidth:Int(Text:String)
    Local Units:Int = 0
    Local i:Int
    Local j:Int
    
    For i = 0 To Text.Length - 1
      If (Text[i] = $20)
        Units += Widths[0]
      else
        For j = 1 To Frames - 1
          If (Chars[j] = Text[i])
            Units += Widths[j]
            Exit
          Endif
        Next j
      Endif
    Next i
    
    Return Units
  End Method
  
  Method Write(x:Int, y:Int, Text:String, Scale:Float, xMid:Bool, yMid:Bool)
    Local i:Int
    Local j:int
    
    If (xMid)
      x -= 0.5 * Scale * MFontWidth(Text)
    Endif
    If (yMid)
      y -= 0.5 * Scale * Img.Height
    Endif
    
    For i = 0 To Text.Length - 1
      If (Text[i] = $20)
        x += Widths[0] * Scale
      Else
        For j = 1 To Frames - 1
          If (Chars[j] = Text[i])
            DrawImage(Img, x, y, 0.0, Scale, Scale, j-1)
            x += Widths[j] * Scale
            Exit
          Endif
        Next j
      Endif
    Next i
  End Method
End Class

Function LoadMFont:MFont(Path:String)
  Local Raw:String[] = LoadString(Path + ".txt").Replace("~r","").Split("~n")
  Local That:MFont = New MFont
  That.Frames = Raw.Length()
  That.Img = LoadImage(Path + ".png", That.Frames - 1)
  That.Chars = New Int[That.Frames]
  That.Widths = New Int[That.Frames]
  
  Local i
  For i = 0 To That.Frames - 1
    That.Chars[i] = Raw[i][0]
    That.Widths[i] = Int(Raw[i][2..])
  Next i
  
  Return That
End Function
